/* Tecnisa - Tecnologia em Informtica

 Descrio:
 Procedimento para execuo da procedure de Movimentao de Estoque

 Criao:
 25/01/05 - Alessandra Cristina

 @C:\WEB_405\Sql\End_Conv\Oracle\4010_ESTSTPO_MovimentacaoFil.SQL
  raise_application_error(-20501, '' , True);
*/

CREATE OR REPLACE PROCEDURE MOVIMENTACAO_FIL(P_FILIAL       IN VARCHAR2,
                                             P_CDALMOXARIFE IN POSESTDIA.CDALMOXARIFE%TYPE,
                                             P_CDLOCALESTOQ IN POSESTDIA.CDLOCALESTOQ%TYPE,
                                             P_NRLOTEESTQ   IN POSESTDIA.NRLOTEESTQ%TYPE,
                                             P_TAMNIVEL     IN INTEGER,
                                             P_DTINICIAL    IN DATE,
                                             P_DTFINAL      IN DATE,
                                             P_PRODINI      IN PRODUTO.CDPRODUTO%TYPE,
                                             P_PRODFIM      IN PRODUTO.CDPRODUTO%TYPE,
                                             P_IDLANCTO     IN INTEGER,
                                             P_IDCUSTO      IN INTEGER,
                                             P_NRLISTA      IN LISTA.NRLISTA%TYPE,
                                             P_MOVCONSOLID  IN VARCHAR DEFAULT 'N',
                                             P_CUSTOALMOX   IN VARCHAR DEFAULT 'N')
AS
   V_NRFILIAL        VARCHAR2(20); -- Cdigo gerado para cada filial
   V_DELMOVIMEN      VARCHAR2(1);
   V_IDUTILALMOX     VARCHAR2(1);
   V_IDUTILLCESTQ    VARCHAR2(1);
BEGIN
   V_DELMOVIMEN := 'S';

   FOR C_FILIAL IN(SELECT CDFILIAL
                   FROM FILIAL
                   WHERE ((INSTR(P_FILIAL,'_'||CDFILIAL||'_') > 0) OR (P_FILIAL = 'T'))) LOOP
      V_DELMOVIMEN := 'N';
      SELECT MAX(IDUTILALMOX), MAX(IDUTILLCESTQ)
      INTO V_IDUTILALMOX, V_IDUTILLCESTQ
      FROM PARAMFILIAL
      WHERE CDFILIAL = C_FILIAL.CDFILIAL;

      NOVO_CODIGO('MOVIESTOQUE', V_NRFILIAL);
      V_NRFILIAL := SUBSTR(V_NRFILIAL, 11, 10);

      INSERT INTO LISTA
         (NRLISTA, CDLISTA)
      VALUES
         (P_NRLISTA , V_NRFILIAL);

      IF (V_IDUTILALMOX = 'S') THEN
         FOR C_ALMOXARIFE IN (SELECT CDALMOXARIFE
                              FROM ALMOXARIFADO
                              WHERE (CDFILIAL  = C_FILIAL.CDFILIAL)      AND
                                    ((INSTR(P_CDALMOXARIFE,'_'||C_FILIAL.CDFILIAL||CDALMOXARIFE||'_') > 0)
                                    OR (P_CDALMOXARIFE = 'T'))) LOOP
            IF (V_IDUTILLCESTQ = 'S') THEN
               FOR C_LOCALESTOQ IN (SELECT CDLOCALESTOQ
                                    FROM LOCALESTOQUE
                                    WHERE (CDFILIAL     = C_FILIAL.CDFILIAL)            AND
                                          (CDALMOXARIFE = C_ALMOXARIFE.CDALMOXARIFE)    AND
                                           ((INSTR(P_CDLOCALESTOQ,'_'||C_FILIAL.CDFILIAL||C_ALMOXARIFE.CDALMOXARIFE||CDLOCALESTOQ||'_') > 0)
                                           OR (P_CDLOCALESTOQ = 'T'))) LOOP

                   MOVIMENTACAO_ESTOQUE(C_FILIAL.CDFILIAL, C_ALMOXARIFE.CDALMOXARIFE, C_LOCALESTOQ.CDLOCALESTOQ, '', P_TAMNIVEL, P_DTINICIAL,
                                        P_DTFINAL, P_PRODINI, P_PRODFIM, P_IDLANCTO, P_IDCUSTO, V_NRFILIAL,  'N', P_CUSTOALMOX, V_DELMOVIMEN);

               END LOOP;
            ELSE
               MOVIMENTACAO_ESTOQUE(C_FILIAL.CDFILIAL, C_ALMOXARIFE.CDALMOXARIFE, '', '', P_TAMNIVEL, P_DTINICIAL,
                                    P_DTFINAL, P_PRODINI, P_PRODFIM, P_IDLANCTO, P_IDCUSTO, V_NRFILIAL,
                                    'N', P_CUSTOALMOX, V_DELMOVIMEN);
            END IF;
         END LOOP;
      ELSE
         MOVIMENTACAO_ESTOQUE(C_FILIAL.CDFILIAL, '', '', '', P_TAMNIVEL, P_DTINICIAL,
                              P_DTFINAL, P_PRODINI, P_PRODFIM, P_IDLANCTO, P_IDCUSTO, V_NRFILIAL,  'N', P_CUSTOALMOX, V_DELMOVIMEN);
      END IF;
   END LOOP;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('MOVIMENTACAO_FIL','5.03.007'); END;
/

